package com.franckbarbier.From_Java_9;

import java.util.stream.Stream;

@java.lang.annotation.Target(value = java.lang.annotation.ElementType.PARAMETER)
@interface Must_be_positive {
}

public class Java_10 {

    public static void main(String[] args) {
        // Java 9 API:
        java.lang.Runtime.Version v = java.lang.Runtime.version();
        System.out.println(v); // For instance: '12.0.2+10' is displayed
        // Java 10 API:
        System.out.println(v.feature()); // For instance: '12' is displayed

        // From Java 10:
        var polynomial = new java.util.HashMap<Double, Double>();
        polynomial.put(1., -12.);
        polynomial.put(39., 8.);

//        java.util.List<Integer> positives = java.util.Arrays.asList(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
//        java.util.stream.Stream<Integer> stream = positives.stream().filter(p -> p > 1 && java.util.stream.IntStream.rangeClosed(2, (int) Math.sqrt(p)).noneMatch(i -> (p % i == 0)));
//        java.util.List<Integer> primes = stream.collect(java.util.stream.Collectors.toList());
//        primes.forEach(p -> System.out.print(" " + p)); // '2 3 5 7 11' is displayed...
        var positives = java.util.Arrays.asList(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
        var stream = positives.stream().filter((@Must_be_positive Integer p) -> p > 1 && java.util.stream.IntStream.rangeClosed(2, (int) Math.sqrt(p)).noneMatch((@Must_be_positive int i) -> (p % i == 0)));
        var primes = stream.collect(java.util.stream.Collectors.toList());
        primes.forEach((@Must_be_positive Integer p) -> System.out.print(" " + p)); // '2 3 5 7 11' is displayed...
    }
}
